
#include "Context.h"

Context::Context (void) {
  threads = ThreadsVector ((unsigned int) 0, (Thread *) NULL);
}

Context::~Context (void) {
  map<string, Reference*>::iterator start, stop;
  start = references.begin();
  stop = references.end();
  for ( ; start != stop; ++start) {
    if ((*start).first != RETURN) {
      delete (*start).second;
    }
  }
  references.clear();
}

void Context::insertReference (const string &referenceName, Reference* reference) {
  if (references.find (referenceName) == references.end()) {
    references[referenceName] = reference;
  }
}

bool Context::eraseReference (const string &referenceName) {
  map<string, Reference*>::iterator finder = references.find (referenceName);
  if (finder != references.end()) {
    references.erase (finder);
    return true;
  }
  return false;
}

ReferencesMap* Context::getReferences (void) {
  return &references;
}

Reference* Context::findReference (const string &referenceName) {
  ReferencesMap::iterator finder = references.find (referenceName);
  return (finder != references.end()) ? (*finder).second : NULL;
}

bool Context::reset (Thread* thread) {
  threads.erase (find (threads.begin(), threads.end(), thread));
    return threads.empty();
}

void Context::set (Thread* thread) {
  threads.resize ((unsigned int) (threads.size() + 1), thread);
}

void Context::printReferences (void) {
  ReferencesMap::const_iterator start, stop;
  start = references.begin();
  stop = references.end();
  for ( ; start != stop; ++start) {
    cout << endl << "  * " << (*start).first;
  }
}
