
#ifndef _Context_h_
#define _Context_h_

#pragma warning (disable : 4786)

#include <vector>
#include <iostream>
#include <string>
#include <algorithm>
#include "Reference.h"
#include "Object.h"

using namespace std;

class Thread;

typedef vector<Thread *> ThreadsVector;

class Context {
  protected:
    ReferencesMap references;
    ThreadsVector threads;
  public:
    Context (void);
    virtual ~Context();
    void insertReference (const string &referenceName, Reference* reference);
    bool eraseReference (const string &referenceName);
    Reference* findReference (const string &referenceName);
    ReferencesMap* getReferences (void);
    bool reset (Thread* thread);
    void set (Thread* thread);
    void printReferences (void);
};

typedef vector<Context *> ContextsVector;

#endif
