
#ifndef _Evaluation_h_
#define _Evaluation_h_

#pragma warning (disable : 4786)

#include "Thread.h"
#include "Parser.h"
#include "Debugger.h"
#include <string>
#include <iostream>
#include <fstream>
#include <strstream>

using namespace std;

class Evaluation {
  private:
    Parser* parser;
    bool finished;
    Thread* thread;
    Evaluation* subEvaluation;
  public:
    Evaluation (istream* is, Context* baseContext);
    Evaluation (istream* is, Thread* _thread);
    virtual ~Evaluation (void);
    bool isFinished (void) const;
    void setFinished (const bool _finished);
    Thread* getThread (void) const;
    void setThread (Thread* _thread);
    Evaluation* getSubEvaluation (void) const;
    void setSubEvaluation (Evaluation* _subEvaluation);
    Evaluation* newSubEvaluation (const string &in);
    void evaluate (void);
    void setBaseContext (Context* baseContext);
};

typedef vector<Evaluation *> EvaluationsVector;

#endif
