
#include "FirstKeyPrimitiveStringObject.h"

FirstKeyPrimitiveStringObject::FirstKeyPrimitiveStringObject (const string &_value): PrimitiveStringObject (_value) {
}

FirstKeyPrimitiveStringObject::~FirstKeyPrimitiveStringObject (void) {
}

void FirstKeyPrimitiveStringObject::evaluate (Thread* thread, const string &objectReferenceName, const string &memberReferenceName, const string &destinationReferenceName, const ParamsList paramsList) {
  PRINT1 ("\n  Ejecucion del miembro 'firstKey'.");
  // Busqueda de la referencia al objeto en el que se buscara el miembro.
  Reference* objectReference = thread->findReference (objectReferenceName);
  if (objectReference == NULL) {
    PRINT1 ("\n    No se ha encontrado la referencia al objeto 'sender'.");
    return;
  }
  // Busqueda de la referencia a 'nil' para futuros usos.
  Reference* nilReference = thread->findReference ("nil");
  if (nilReference == NULL) {
    PRINT1 ("\n    Referencia 'nil' no encontrada.");
    return;
  }
  // Busqueda de la referencia al objeto 'return'.
  Reference* destinationReference = NULL;
  if (destinationReferenceName == "") {
    PRINT1 ("\n    No se ha indicado la referencia de destino.");
    return;
  }
  else {
    destinationReference = thread->findReference (destinationReferenceName);
    if (destinationReference == NULL) {
      PRINT1 ("\n    '" + destinationReferenceName + "' no encontrada (referencia destino).");
      PRINT1 ("\n    Creacion de la nueva referencia: " + destinationReferenceName + " (apunta a 'nil').");
      destinationReference = new Reference (nilReference->getObject());
      thread->getLastContext()->insertReference (destinationReferenceName, destinationReference);
      PRINT1 ("\n    Referencia '" + destinationReferenceName + "' creada correctamente.");
    }
  }
  // Busqueda de la referencia a 'String' para futuros usos.
  Reference* stringReference = thread->findReference ("String");
  if (stringReference == NULL) {
    PRINT1 ("\n    Referencia 'String' no encontrada.");
    return;
  }
/*
  // Busqueda de la clave del primer miembro del objeto.
  string firstKeyName = objectReference->getObject()->firstKey();
  if (firstKeyName != "") {
    PRINT1 ("\n    Primera clave encontrada: " + firstKeyName + ".");    
    // Creacion del StringObject en el que devolver el resultado.
    StringObject* so = new StringObject (firstKeyName);
    so->insertMember (ID, new Reference (so));
    so->insertMember (SUPER, new Reference (stringReference->getObject()));
    // Devolucion del resultado.
    destinationReference->setObject (so);
  }
  else {
    PRINT1 ("\n    Primera clave no encontrada. Se devuelve una referencia a 'nil'.");
    destinationReference->setObject (nilReference->getObject());
  }
*/
  Reference* firstKeyReference = objectReference->getObject()->firstKey();
  if (firstKeyReference == NULL)
    destinationReference->setObject (nilReference->getObject());
  else
    destinationReference->setObject (firstKeyReference->getObject());
}
