
#include "InvokePrimitiveStringObject.h"
// * port #include "extern/statement.h"

const char * (*invoke)(const char *,const char *,const char *,const char *);


InvokePrimitiveStringObject::InvokePrimitiveStringObject (const string &_value): PrimitiveStringObject (_value) {
  // * port CoInitialize (NULL);
}

InvokePrimitiveStringObject::~InvokePrimitiveStringObject (void) {
  // * port CoUninitialize();
}

// * port
/*
void InvokePrimitiveStringObject::errorCOM (_com_error &e) {
  PRINT1 ("\n----------------------------------------------");
  PRINT1 ("\nError COM");
	PRINT2 ("\n  Codigo: %d\n", e.Error());
	PRINT1 ("\n  Significado: " + string (e.ErrorMessage()));
  _bstr_t bstrOrigen (e.Source());
  _bstr_t bstrDescripcion (e.Description());
  TPRINT("\n  Origen: %s.", (LPCTSTR)bstrOrigen);
  TPRINT("\n  Descripcion: %s.", (LPCTSTR)bstrDescripcion);
  PRINT1 ("\n----------------------------------------------");
} */

void InvokePrimitiveStringObject::evaluate (Thread* thread, const string &objectReferenceName, const string &memberReferenceName, const string &destinationReferenceName, const ParamsList paramsList) {
  PRINT1 ("\n  Ejecucion del miembro 'invoke'.");
  // Busqueda de la referencia a 'nil' para futuros usos.
  Reference* nilReference = thread->findReference ("nil");
  if (nilReference == NULL) {
    PRINT1 ("\n    Referencia 'nil' no encontrada.");
    return;
  }
  // Busqueda de la referencia a 'String' para futuros usos.
  Reference* stringReference = thread->findReference ("String");
  if (stringReference == NULL) {
    PRINT1 ("\n    Referencia 'String' no encontrada.");
    return;
  }
  // Analisis de los parametros.
  if (paramsList.size() != 4) {
    PRINT1 ("\n    No se han indicado cuatro parametros.");
    return;
  }
  string params[4];
  ParamsList::const_iterator start, stop;
  start = paramsList.begin();
  stop = paramsList.end();
  int i = 0;
  for ( ; start != stop; ++start) {
    PRINT2 ("\n    Parametro %d: " + (*start), i);
    Reference* paramReference = thread->findReference (*start);
    if (paramReference == NULL) {
      PRINT2("\n    No se ha encontrado la referencia correspondiente al parametro %d (" + (*start) + "). Se intenta crear una nueva con el objeto correspondiente.", i);
      if (Basic::isNitroString (*start)) {
        PRINT2("\n    El parametro %d es un 'NitroString' por lo que se crea un nuevo objeto y una nueva referencia al mismo.", i);
        StringObject* stringObjectParam = new StringObject (*start);
        stringObjectParam->insertMember (ID, new Reference (stringObjectParam));
        stringObjectParam->insertMember (SUPER, new Reference (stringReference->getObject()));
        ThreadPool::threadPool.getBaseContext()->insertReference ((*start), new Reference (stringObjectParam));
        paramReference = new Reference (stringObjectParam);
      }
      else {
        PRINT2("\n    No se ha encontrado el parametro %d (" + (*start) + ") y no es un 'NitroString'.", i);
        return;
      }
    }
    else {
      PRINT2("\n    Se ha encontrado la referencia correspondiente al parametro %d (" + (*start) + ").", i);
    }
    StringObject* so = dynamic_cast<StringObject*>(paramReference->getObject()->findMember(ID)->getObject());
    if (so != NULL) {
      params[i] = so->getValue();
      PRINT1 ("\n      ID del objeto correspondiente: " + params[i]);
    }
    else
      return;
    i++;
  }

  /*
	// * nitrOLib: Componente (namespace)
	// * IEnteroPtr: Wrapper a un Interface
	nitrOLib::IExternPtr ptrExtern;
	// * Para saber si hubo errores
	HRESULT hr = S_OK;
	try {
		// * CreateInstance es una creacin de un interface
		//   a partir de una coClase pasndole el universal
		//   unique interface del Interface
		hr = ptrExtern.CreateInstance (__uuidof (nitrOLib::nitrO));
		// * Errores?
		if (FAILED (hr)) {
			_com_issue_error (hr);
		}
    PRINT1 ("\n    invoke (" + params[0] + ", " + params[1] + ", " + params[2] + ", " + params[3] + ")");
		// * Se accede a los servicios mediante el operador ->
		string result = ptrExtern->invoke ((wchar_t*)_bstr_t(params[0].c_str()), (wchar_t*)_bstr_t(params[1].c_str()), (wchar_t*)_bstr_t(params[2].c_str()), (wchar_t*)_bstr_t(params[3].c_str()));
		*/
    // * ORTIN: YA NO ES COM
  const char *result=::invoke(params[0].c_str(),params[1].c_str(),params[2].c_str(),params[3].c_str());
    PRINT1 ("\n    Resultado de invoke: " + result);
    Reference* destinationReference = thread->findReference (destinationReferenceName);
    if (destinationReference == NULL) {
      // Busqueda de la referencia a 'nil' para futuros usos.
      Reference* nilReference = thread->findReference ("nil");
      if (nilReference == NULL) {
        PRINT1 ("\n    Referencia 'nil' no encontrada.");
        return;
      }
      PRINT1 ("\n    '" + destinationReferenceName + "' no encontrada (referencia destino).");
      PRINT1 ("\n    Creacion de la nueva referencia: " + destinationReferenceName + ".");
      destinationReference = new Reference (nilReference->getObject());
      thread->getLastContext()->insertReference (destinationReferenceName, destinationReference);
    }
    Reference* resultReference = thread->findReference (result);
    if (resultReference == NULL) {
      if (Basic::isNitroString (result)) {
        PRINT1 ("\n    El resultado " + result + " es un 'NitroString' por lo que se crea un nuevo objeto y una nueva referencia al mismo.");
        StringObject* resultObject = new StringObject (result);
        resultObject->insertMember (ID, new Reference (resultObject));
        resultObject->insertMember (SUPER, new Reference (stringReference->getObject()));
        resultReference = new Reference (resultObject);
        thread->getLastContext()->insertReference (result, resultReference);
        destinationReference->setObject (resultReference->getObject());
      }
      else {
        PRINT1 ("\n    No se ha encontrado el objeto resultado. Se devuelve 'nil'");
        destinationReference->setObject (nilReference->getObject());
        return;
      }
    }
    else
      destinationReference->setObject (resultReference->getObject());
  /*}
	catch (_com_error &e) {
		errorCOM (e);
	}*/
}
