#include <string>
#include "ThreadPool.h"
#include "Basic.h"
#include "Service.h"
#include "InvokePrimitiveStringObject.h"
#include <dlfcn.h>

using namespace std;

void *loadExternInvokeFunction() {
   void* handle;
   char* error;
   handle = dlopen ("./extern/libextern.so", RTLD_LAZY);
   error = dlerror ();
   if (error)   { /* If so, print the error message and exit. */
         printf ("%s\n", error);
         exit (1);
      }
   invoke = ( const char * (*)(const char *,const char *,const char *,const char *) )
            dlsym (handle, "invoke__FPCcN30");

   error = dlerror ();
/* Check to see if there were any errors in getting the function. */
   if (error)      {
         /* If so, print the error message and exit. */
         printf ("%s\n", error);
         exit (1);
      }

   return handle;
}

int main (int argc, char* argv[]) {

  string imageName;
  (argc == 2) ? imageName = string (argv[1]) : imageName = "image.nitrO";

  void *externHandle=loadExternInvokeFunction();

  ThreadPool::threadPool.loadImage (imageName);
  ThreadPool::threadPool.run();

  cout<<"nitroVM> Image loaded. Waiting for commands."<<endl;
  
  service();

   /* Close the shared library. */
  dlclose (externHandle);
}
