
#ifndef _Object_h_
#define _Object_h_

#pragma warning (disable : 4786)

#include <string>
#include <list>
#include <iostream>
// * port #include <objbase.h>
#include <string>
#include <sstream>
#include <stack>
#include <vector>
#include <iomanip>
//#include "Thread.h"
#include "Basic.h"
#include "Reference.h"

using namespace std;

class Thread;

typedef stack<Thread *> ThreadsStack;

class Object {
  private:
	bool locked;
    Object (const Object &) {}
    Object &operator= (const Object &) { return *this; }
    int refCount;
    bool twoPointsLocked;
  protected:
    ReferencesMap members;
    //static Object System;
    Object (int); // * Constructor unicamente para System.
    ThreadsStack threadsLocked;
  public:
    Object (const string &name);
    virtual ~Object (void);
    static Object System;
    ReferencesMap &getMembers (void);
    bool insertMember (const string &memberName, Reference* member);
    bool updateMember (const string &memberName, Reference* member);
    Reference* findMember (const string &memberName);
    Reference* findMemberOwner (const string &memberName);
    Reference* findLocalMember (const string &memberName);
    Reference* findLocalMember (Reference* _memberReference);
    Reference* nextKey (const string &memberName);
    Reference* nextKey (Reference* _memberReference);
    Reference* getSuper (void);
    Reference* getId (void);
    void removeMember (const string &memberName);
    bool isNil (void);
    bool isLocked (void) const;
    void setLocked (const bool _locked);
    void lock (Thread* thread);
    void unlock (void);
    int getRefCount (void) const;
    void printMembers (void) const;
    void incRefCount (void);
    void decRefCount (void);
    Reference* firstKey (void) const;
    void lockTwoPoints (void);
    void unlockTwoPoints (void);
    bool isTwoPointsLocked (void);
};

#endif

