
#ifndef _Parser_h_
#define _Parser_h_

#pragma warning (disable : 4786)

#include <iostream>
#include <string>
#include <stdlib.h>
#include "Statement.h"
#include "AssignReferenceStatement.h"
#include "CommentStatement.h"
#include "MemberAccessStatement.h"
#include "MemberEvaluationStatement.h"
#include "SynchronousMemberEvaluationStatement.h"
#include "AsynchronousMemberEvaluationStatement.h"
#include "NewReferenceStatement.h"
#include "StringEvaluationStatement.h"
#include "SynchronousStringEvaluationStatement.h"
#include "AsynchronousStringEvaluationStatement.h"
#include "ReferenceEvaluationStatement.h"
#include "SynchronousReferenceEvaluationStatement.h"
#include "AsynchronousReferenceEvaluationStatement.h"
#include "Lexer.h"
#include "Debugger.h"

using namespace std;

class Parser {
  private:
    Lexer* lexer;
  public:
    Parser (istream* _data);
    virtual ~Parser (void);
    Statement* nextStatement (void);
    Statement* restAssignReference (const string &destinationReferenceName);
    bool parameter (ParamsList &_paramsList);
    bool paramsList (ParamsList &_paramsList);
    bool parameters (ParamsList &_paramsList);
    bool isFinished (void);
};

#endif
