
#ifndef _Reference_h_
#define _Reference_h_

#pragma warning (disable : 4786)

#include <string>
#include <vector>
#include <map>

using namespace std;

class Object;

class Reference {
  private:
	  Reference (Reference&) {}
    Reference& operator=(Reference&) { return *this; }
    // Prohibimos (poniendo en la parte privada) tomar
    // la direccion de referencias para eliminar posibles
    // errores.
    Reference* operator&() { return this; }
  protected:
    Object* object;
  public:
    // Reference (void); Prohi.
    Reference (Object* _object);
    Reference (Object* _object, bool system);
    virtual ~Reference (void);
    Object* getObject (void);
    void setObject (Object *_object);
    void deleteObject (void);
};

typedef vector<Reference*> ReferencesVector;

typedef map<string, Reference*> ReferencesMap;

#endif
