
#include "RemovePrimitiveStringObject.h"

RemovePrimitiveStringObject::RemovePrimitiveStringObject (const string &_value): PrimitiveStringObject (_value) {
}

RemovePrimitiveStringObject::~RemovePrimitiveStringObject (void) {
}

void RemovePrimitiveStringObject::evaluate (Thread* thread, const string &objectReferenceName, const string &memberReferenceName, const string &destinationReferenceName, const ParamsList paramsList) {
  PRINT1 ("\n  Ejecucion del miembro 'get'.");
  // Busqueda de la referencia a 'String' para futuros usos.
  Reference* stringReference = thread->findReference ("String");
  if (stringReference == NULL) {
    PRINT1 ("\n    Referencia 'String' no encontrada.");
    return;
  }
  // Busqueda de la referencia al objeto en el que se eliminara el miembro.
  Reference* objectReference = thread->findReference (objectReferenceName);
  if (objectReference == NULL) {
    PRINT1 ("\n    No se ha encontrado la referencia al objeto 'sender'.");
    return;
  }
  // Busqueda de la referencia al objeto que indica la clave a eliminar.
  if (paramsList.size() == 1) {
    // Analisis del parametro 0.
    Reference* param0Reference = thread->findReference (paramsList.front());
    if (param0Reference == NULL) {
      PRINT1 ("\n    No se ha encontrado la referencia correspondiente al parametro 0 (" + paramsList.front() + "). Se intenta crear una nueva con el objeto correspondiente.");
      if (Basic::isNitroString (paramsList.front())) {
        PRINT1 ("\n    El parametro 0 es un 'NitroString' por lo que se crea un nuevo objeto y una nueva referencia al mismo.");
        StringObject* stringObjectParam0 = new StringObject (paramsList.front());
        stringObjectParam0->insertMember (ID, new Reference (stringObjectParam0));
        stringObjectParam0->insertMember (SUPER, new Reference (stringReference->getObject()));
        param0Reference = new Reference (stringObjectParam0);
      }
      else {
        PRINT1 ("\n    No se ha encontrado el parametro 0 (" + paramsList.front() + ") y no es un 'NitroString'.");
        return;
      }
    }
    StringObject* so = dynamic_cast<StringObject*>(param0Reference->getObject()->getId()->getObject());
    if (so != NULL) {
      objectReference->getObject()->removeMember (so->getValue());
    }
    else {
      PRINT1 ("\n    No se ha podido acceder al identificador del parametro 0.");
      return;
    }
  }
  else {
    PRINT1 ("\n    No se ha indicado un unico parametro.");
    return;
  }
}
