#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <unistd.h>
#include <iostream>
#include <string>
#include <fstream>
#include <sstream>
#include "Machine.h"

using namespace std;

#include <linux/stat.h>
#define PIPE "nitrOVMpipe"

#include "lex.h"

void evaluate(const string &command,istream &in) {
     if (!command.compare("newReference")) {
        string referencia=yylex(&in);
        cout<<"nitroVM> Command: "<<command<<"\n\tReference: "<<referencia<<endl;
	 newReference(referencia);
        return;
     }
     if (!command.compare("getMember")) {
        string objeto=yylex(&in),miembro=yylex(&in),
               resultado=yylex(&in);
        cout<<"nitroVM> Command: "<<command<<"\n\tObject: "<<objeto<<
                        "\n\tMember: "<<miembro<<
                        "\n\tResult: "<<resultado<<endl;
	 getMember(objeto,miembro,resultado);
        return;
     }
     if (!command.compare("evaluateMemberSync")) {
        string objeto=yylex(&in),miembro=yylex(&in),
               parametros=yylex(&in),resultado=yylex(&in);
        cout<<"nitroVM> Command: "<<command<<"\n\tObject: "<<objeto<<
                        "\n\tMember: "<<miembro<<
                        "\n\tParams: "<<parametros<<
                        "\n\tResult: "<<resultado<<endl;
	 evaluateMemberSync(objeto,miembro,parametros,resultado);
        return;
     }
     if (!command.compare("evaluateMemberAync")) {
        string objeto=yylex(&in),miembro=yylex(&in),
               parametros=yylex(&in);
        cout<<"nitroVM> Command: "<<command<<"\n\tObject: "<<objeto<<
                        "\n\tMember: "<<miembro<<
                        "\n\tParams: "<<parametros<<endl;
	 evaluateMemberAsync(objeto,miembro,parametros);
        return;
     }
     if (!command.compare("evaluateStringSync")) {
        string codigo=yylex(&in),parametros=yylex(&in),
               resultado=yylex(&in);
        cout<<"nitroVM> Command: "<<command<<"\n\tCode: "<<codigo<<
                        "\n\tParams: "<<parametros<<
                        "\n\tResult: "<<resultado<<endl;
	 evaluateStringSync(codigo,parametros,resultado);
        return;
     }
     if (!command.compare("evaluateStringAsync")) {
        string codigo=yylex(&in),parametros=yylex(&in);
        cout<<"nitroVM> Command: "<<command<<"\n\tCode: "<<codigo<<
                        "\n\tParams: "<<parametros<<endl;
	 evaluateStringAsync(codigo,parametros);
        return;
     }
     if (!command.compare("shutdown")) {
        cout<<"nitroVM> Command: "<<command<<".\n\tThe end.\n"<<endl;
        exit(0);
     }
     cerr<<"nitroVM> Unknown command: "<<command<<endl;
}

void service() {
        // * Creates the pipe
    umask(0);
    mknod(PIPE, S_IFIFO|0666, 0);

    ifstream channel;
    string command;
    channel.open(PIPE);

     while(1) {
		if (!channel) {
			cerr<<"Cannot open the channel "<<PIPE<<".\n";
			exit(-1);
		}
        command=yylex(&channel);
        evaluate(command,channel);
        }
     channel.close();

}