
#include "SetPrimitiveStringObject.h"

SetPrimitiveStringObject::SetPrimitiveStringObject (const string &_value): PrimitiveStringObject (_value) {
}

SetPrimitiveStringObject::~SetPrimitiveStringObject (void) {
}

void SetPrimitiveStringObject::evaluate (Thread* thread, const string &objectReferenceName, const string &memberReferenceName, const string &destinationReferenceName, const ParamsList paramsList) {
  PRINT1 ("\n  Ejecucion del miembro 'set'.");
  // Busqueda de la referencia a 'String' para futuros usos.
  Reference* stringReference = thread->findReference ("String");
  if (stringReference == NULL) {
    PRINT1 ("\n    Referencia 'String' no encontrada.");
    return;
  }
  // Busqueda del objeto al que aadir el nuevo miembro.
  Reference* objectReference = NULL;
  if ((objectReference = thread->findReference (objectReferenceName)) == NULL) {
    PRINT1 ("\n    No se ha encontrado la referencia correspondiente al objeto al que aadir el miembro.");
    if (Basic::isNitroString (objectReferenceName)) {
      PRINT1 ("\n    El objeto es un 'NitroString' por lo que se crea un nuevo objeto y una nueva referencia al mismo.");
      StringObject* object = new StringObject (objectReferenceName);
      objectReference = new Reference (object);
      object->insertMember (ID, new Reference (object));
      object->insertMember (SUPER, new Reference (stringReference->getObject()));
      ThreadPool::threadPool.getBaseContext()->insertReference (objectReferenceName, new Reference (object));
    }
    else {
      PRINT1 ("\n    El objeto '" + objectReferenceName + "' no es un 'NitroString'.");
      return;
    }
  }
  if (paramsList.size() != 2) {
    PRINT1 ("\n    No se han indicado dos parametros.");
    return;
  }
  //
  PRINT1 ("\n    Miembro a insertar/modificar: " + paramsList.front());
  // Analisis del parametro 1.
  Reference* param1Reference = thread->findReference (paramsList.back());
  if (param1Reference == NULL) {
    PRINT1 ("\n    No se ha encontrado la referencia correspondiente al parametro 1 (" + paramsList.back() + "). Se intenta crear una nueva con el objeto correspondiente.");
    if (Basic::isNitroString (paramsList.back())) {
      PRINT1 ("\n    El parametro 1 es un 'NitroString' por lo que se crea un nuevo objeto y una nueva referencia al mismo.");
      StringObject* stringObjectParam1 = new StringObject (paramsList.back());
//**      StringObject* stringObjectParam1 = new StringObject (Basic::nitroStringToString (paramsList.back()));
      stringObjectParam1->insertMember (ID, new Reference (stringObjectParam1));
      stringObjectParam1->insertMember (SUPER, new Reference (stringReference->getObject()));
      ThreadPool::threadPool.getBaseContext()->insertReference (paramsList.back(), new Reference (stringObjectParam1));
      objectReference->getObject()->updateMember (paramsList.front(), new Reference (stringObjectParam1));
    }
    else {
      PRINT1 ("\n    No se ha encontrado el parametro 1 (" + paramsList.back() + ") y no es un 'NitroString'.");
      return;
    }
  }
  else {
    PRINT1 ("\n    Se ha encontrado la referencia correspondiente al parametro 1 (" + paramsList.back() + ").");
    objectReference->getObject()->updateMember (paramsList.front(), new Reference (param1Reference->getObject()));
  }
}
