
#include "Thread.h"

Thread::Thread (void) {
  locked = false;
  contexts = ContextsVector ((unsigned int) 0, (Context *) NULL);
}

Thread::~Thread (void) {
  //** delete contexts;
}

bool Thread::isLocked (void) const {
  return locked;
}

void Thread::setLocked (const bool _locked) {
  locked = _locked;
}

void Thread::newContext (void) {
  insertContext (new Context());
}

void Thread::deleteLastContext (void) {
  if (contexts.size() > 0) {
    delete contexts.back();
    contexts.pop_back();
  }
}

void Thread::assignContexts (void) {
}

void Thread::insertContext (Context* context) {
  context->set (this);
  contexts.resize ((unsigned int) (contexts.size() + 1), context);
}

Reference* Thread::findReference (const string &referenceName) {
  Reference* reference = NULL;
  for (ContextsVector::reverse_iterator i = contexts.rbegin(); (i != contexts.rend()) && ((reference = (*i)->findReference (referenceName)) == NULL); ++i);
  return reference;
}

Context* Thread::getLastContext (void) {
  return (contexts.size() > 0) ? contexts.back() : NULL;
}

