
#ifndef _Thread_h_
#define _Thread_h_

#pragma warning (disable : 4786)

#include "Context.h"
#include "Reference.h"
#include <list>

using namespace std;

class Thread {
  private:
    ContextsVector contexts;
    bool locked;
  public:
    Thread (void);
    virtual ~Thread (void);
    bool isLocked (void) const;
    void setLocked (const bool _locked);
    void newContext (void);
    void deleteLastContext (void);
    void assignContexts (void);
    void insertContext (Context* context);
    Reference* findReference (const string &referenceName);
    Context* getLastContext (void);
};

#endif
