#ifndef _ThreadPool_h_
#define _ThreadPool_h_

#pragma warning (disable : 4786)

#include <iostream>
#include <sstream>
#include <vector>
#include <list>
#include "Thread.h"
#include "Object.h"
#include "StringObject.h"
#include "PrimitiveStringObject.h"
#include "NewPrimitiveStringObject.h"
#include "DeletePrimitiveStringObject.h"
#include "SetPrimitiveStringObject.h"
#include "HasPrimitiveStringObject.h"
#include "FirstKeyPrimitiveStringObject.h"
#include "NextKeyPrimitiveStringObject.h"
#include "RemovePrimitiveStringObject.h"
#include "GetPrimitiveStringObject.h"
#include "EnterPrimitiveStringObject.h"
#include "ExitPrimitiveStringObject.h"
#include "LockTwoPointsPrimitiveStringObject.h"
#include "UnlockTwoPointsPrimitiveStringObject.h"
#include "InvokePrimitiveStringObject.h"
#include "GetRefCountPrimitiveStringObject.h"
#include "PrintPrimitiveStringObject.h"
#include "Reference.h"
#include "Evaluation.h"
#include "Context.h"
#include "Debugger.h"

using namespace std;

class ThreadPool {
  private:
    ThreadPool (void);
    Context* baseContext;
    filebuf fileBuffer;
    Evaluation* currentEvaluation;
    EvaluationsVector evaluations;
    vector<int> finishedEvaluations;
  public:
    void loadImage (const string& imageName);
    virtual ~ThreadPool (void);
    Evaluation* newEvaluation (istream* is);
    Evaluation* newEvaluation (istream* is, Thread* thread);
    void run (void);
    Context* getBaseContext (void);
    Evaluation* getCurrentEvaluation (void);
    void setCurrentEvaluation (Evaluation* _currentEvaluation);
    int evaluationsSize (void);
    Thread* getThreadOfEvaluation (int evaluationPosition);
    bool isEvaluationFinished (int evaluationPosition);
    int isEvaluationFinished (Evaluation* evaluation);
    void evaluateEvaluation (int evaluationPosition);
    void eraseFinishedEvaluations (void);
    void insertFinishedEvaluation (int evaluationPosition);
    // Solo se permite la existencia de un unico "threadPool" en el sistema.
    static ThreadPool threadPool;
};

#endif
