
#include "arithmetic.h"
#include "lexer.h"
#pragma warning (disable:4715)

// * Arithmetic Operations
const string arithmetic(const string &op1,const string &op2,char op) {
	bool op1IsInteger=isInteger(op1),op1IsReal=isReal(op1);

	// * Is Op1 Numeric?
	if ( !op1IsInteger && !op1IsReal ) 
		// * Op1 is not Numeric
		if ( op=='+' && isString(op2) )
			// * Concatenation
			return setString(string(getString(op1))+=getString(op2));
		else return "nil";

	// * Op1 is Numeric, is it Op2?
	bool op2IsInteger=isInteger(op2),op2IsReal=isReal(op2);
	if ( !op2IsInteger && !op2IsReal )
		if ( op=='+' && isString(op2) )
			// * Concatenation
			return setString(string(getString(op1))+=getString(op2));
		else return "nil";

	// * Both are Numeric
	if ( op=='%' && (op1IsReal||op2IsReal) )
		return "nil";

	switch (op1IsInteger) {
		case true: switch (op2IsInteger) {
				case true: return operate(toInteger(op1),toInteger(op2),op);
				case false: return operate((double)toInteger(op1),toReal(op2),op);
				   }
		case false: switch (op2IsInteger) {
				case true: return operate(toReal(op1),(double)toInteger(op2),op);
				case false: return operate(toReal(op1),toReal(op2),op);
					}
		}
return "nil";
}


const string operate(double op1, double op2, char op) {
	switch (op) {
	case '+': return setString(toString(op1+op2));
	case '-': return setString(toString(op1-op2));
	case '*': return setString(toString(op1*op2));
	case '/': return setString(toString(op1/op2));
	}
return "nil";
}

const string operate(long op1, long op2, char op) {
	switch (op) {
	case '+': return setString(toString(op1+op2));
	case '-': return setString(toString(op1-op2));
	case '*': return setString(toString(op1*op2));
	case '/': return setString(toString(op1/op2));
	case '%': return setString(toString(op1%op2));
	}
return "nil";
}
