// * Francisco Ortn Soler
// * University of Oviedo
// * Novembre 2001


#include <iostream>
#include <string>

#include <stdio.h>
#include <dlfcn.h>

using namespace std;


#include <stdio.h>
#include <dlfcn.h>

const char * (*invoke)(const char *,const char *,const char *,const char *);

void run();

/* using the dl* functions to load and use a shared library */

int main ()
{
   void* handle;
   char* error;

   handle = dlopen ("./libextern.so", RTLD_LAZY);

   error = dlerror ();
   if (error)   {
         /* If so, print the error message and exit. */
         printf ("%s\n", error);
         exit (1);
      }

   /* Get the 'b_printer' function out of the library. */
   invoke = ( const char * (*)(const char *,const char *,const char *,const char *) )
            dlsym (handle, "invoke__FPCcN30");

   error = dlerror ();
/* Check to see if there were any errors in getting the function. */
   if (error)      {
         /* If so, print the error message and exit. */
         printf ("%s\n", error);
         exit (1);
      }

   /* Call the function. */
   run();

   /* Close the shared library. */
   dlclose (handle);
}


// * Testing Application
void run() {
	const struct Statement{
		char op1[20],op2[20],op[20];
	} statements [] = { 
		{"<33>","<-33>","<+>"},
		{"33","22","<+>"},
		{"<15>","<-2.0>","<+>"},
		{"<+1.1E+1>","<34.e-1>","<+>"},
		{"<Hola>","<Mundo>","<+>"},
		{"Hola","Mundo","<+>"},		
		{"<33>","33","<+>"},

		{"<-1>","<2.E1>","<->"},
		{"<1.0>","<2.E1>","<->"},
		{"<-1>","<2>","<->"},

		{"<-1>","<2.E1>","<*>"},
		{"<1.0>","<2.E1>","<*>"},
		{"<-1>","<2>","<*>"},

		{"<-1>","<2.E1>","</>"},
		{"<1.0>","<2.E1>","</>"},
		{"<-1>","<2>","</>"},

		{"<-1>","<2.E1>","<%>"},
		{"<1.0>","<2.E1>","<%>"},
		{"<-1>","<2>","<%>"},

		{"<Hola>","<Hola>","<==>"},
		{"<Hola>","<hola>","<==>"},
		{"<3>","<3.0>","<==>"},
		{"<3>","<3.1>","<==>"},
		{"<3>","3","<==>"},

		{"<Hola>","<Hola>","<\\<>"},
		{"<Hola>","<Holb>","<\\<>"},
		{"<3>","<3.0>","<\\<>"},
		{"<3>","<3.1>","<\\<>"},
		{"<3>","3","<\\<>"},

		{"<Hola>","<Mundo>","<append>"},
		{"<Hola>","Mundo","<append>"},
	
		{"<Hola>","","<length>"},
		{"Hola","","<length>"}

	};

	for (int i=0;i<sizeof(statements)/sizeof(Statement);i++) {
		cout<<"Op1: "<<statements[i].op1<<"\tOp2: "<<statements[i].op2<<
			"\tOperator: "<<statements[i].op<<"\tResult: "<<
			invoke("String",statements[i].op,statements[i].op1,statements[i].op2)<<endl;
	}

}
