#include "lexer.h"


// * Integer Recognision
bool isInteger(const string & s) {
  if (!isString(s)) return 0;
  int i=1;
  if ( s[i]=='-' || s[i]=='+' ) i++;
  while ( i<s.length()-2 ) {
	  if ( s[i]<'0' || s[i]>'9' ) return 0;
	  i++;
  }
  return 1;
}

// * Real Recognision
bool isReal(const string & s) {
  if (!isString(s)) return 0;
  int i=1;
  if ( s[i]=='-' || s[i]=='+' ) i++;
  while ( s[i]!='.' ) {
	  if ( s[i]<'0' || s[i]>'9' ) return 0;
	  i++;
  }
  i++;
  while ( i<s.length()-2 && s[i]!='E' && s[i]!='e' ) {
	  if ( s[i]<'0' || s[i]>'9' ) return 0;
	  i++;
  }
  if ( s[i]=='E' || s[i]=='e' ) {
	  i++;
	  if ( s[i]=='+' || s[i]=='-' ) i++;
	  while ( i<s.length()-2 ) {
		  if ( s[i]<'0' || s[i]>'9' ) return 0;
		i++;
	  }
  }
  return 1;
}


// * Tells whether the string is inside <> characters
bool isString(const string &s) {
	return s[0]=='<' && s[s.length()-1]=='>';
}

// * Returns the string without the <> characters
const string getString(const string &s) {
	char *p=new char [s.length()-1];
	strncpy(p,s.c_str()+1,s.length()-2);
	p[s.length()-2]='\0';
	string result(p);
	delete [] p;
	return result;
}

// * Puts the <> characters to the string  
const string setString(const string &s) {
	return (string("<")+=s)+=">";
}

// * Integer Conversion
long toInteger(const string &s) {
	return atol(getString(s).c_str());
}

// * Real Conversion
double toReal(const string &s) {
	return atof(getString(s).c_str());
}

const string toString(long n) {
	return ((stringstream&)(stringstream()<<n)).str();
}

const string toString(double n) {
	if (n-(long)(n)==0)
		return ((stringstream&)(stringstream()<<n<<".0")).str();
	return ((stringstream&)(stringstream()<<n)).str();
}

const string toBoolean(int b) {
	return b?"true":"false";
}
