#include "statement.h"
#include "lexer.h"
#include "arithmetic.h"

// * Operands Comparison
const string comparison(const string &op1,const string &op2,char op) {
	bool op1IsInteger=isInteger(op1),op1IsReal=isReal(op1);
	// * Is Op1 Numeric?
	if ( !op1IsInteger && !op1IsReal )  {
		// * Op1 is not Numeric
		if (op=='=') return toBoolean(!op1.compare(op2));
		if (op=='<') return toBoolean(op1.compare(op2)<0);
	}

	bool op2IsInteger=isInteger(op2),op2IsReal=isReal(op2);
	// * Is Op2 Numeric?
	if ( !op2IsInteger && !op2IsReal ) {
		// * Op2 is not Numeric
		if (op=='=') return toBoolean(!op1.compare(op2));
		if (op=='<') return toBoolean(op1.compare(op2)<0);
	}

	// * Both are Numeric
	if (op=='=') return toBoolean(toReal(op1)==toReal(op2));
	return toBoolean(toReal(op1)<toReal(op2));
}

// * ORTIN las cuatro siguientes funciones
long recursiveFactorial(long n) {
	if (n<=1) return 1;
	return n*recursiveFactorial(n-1);
}
const string fact(const string &sender) {
	long n=toInteger(sender);
	volatile int b=20;
	for (int i=0;i<n;i++) recursiveFactorial(b);
	return setString(toString((long)b));
}
#include <map>
#include <iostream>
#include <time.h>
using namespace std;
map<string,int> tabla;
string rellenar(const string &sender) {
	long n=toInteger(sender);
	for (long i=0;i<n;i++)
		tabla[toString(i)]=n-i;
	return "";
}
string ordenar() {
	clock_t start,end;
	start=clock();
	long size=tabla.size();
	for (long i=0;i<size-1;i++)
		for (long j=size-1;j>i;j--) {
			int tablai=tabla[toString(i)],tablaj=tabla[toString(j)];
			if (tablai>tablaj) {
				int temp=tablai; 
				tablai=tablaj;
				tablaj=temp;
			}
		}
	end=clock();
	cout<<(double)(end-start) / CLOCKS_PER_SEC;
	return "";
}

// * Main Extern execution method
const char *invoke(const char *t,const char *m,const char *s,const char *p) {
       const string trait(t);
	const string member(m);
	const string self(s);
	const string params(p);

	if ( trait.compare("String") ) return "nil";

	// * String is the trait object
	// * Different members
	if ( !member.compare("<fact>") ) return fact(self).c_str(); // * ORTIN
	if ( !member.compare("<rellenar>") ) return rellenar(self).c_str(); // * ORTIN
	if ( !member.compare("<ordenar>") ) return ordenar().c_str(); // * ORTIN
	extern string runMD();
	if ( !member.compare("<runMD>") ) return runMD().c_str(); // * ORTIN
	if ( !member.compare("<==>") ) return comparison(self,params,'=').c_str();
	if ( !member.compare("<<>") ) return comparison(self,params,'<').c_str();
	if ( !member.compare("<+>") ) return arithmetic(self,params,'+').c_str();
	if ( !member.compare("<->") ) return arithmetic(self,params,'-').c_str();
	if ( !member.compare("<*>") ) return arithmetic(self,params,'*').c_str();
	if ( !member.compare("</>") ) return arithmetic(self,params,'/').c_str();
	if ( !member.compare("<%>") ) return arithmetic(self,params,'%').c_str();
	if ( !member.compare("<append>") ) return append(self,params).c_str();
	if ( !member.compare("<length>") ) return length(self).c_str();

	return "nil";
}

// * String concatenation
const string append(const string &self,const string &param) {
	if (isString(self) && isString(param) )
		return setString(string(getString(self))+=getString(param));
	return "nil";
}

// * String length
const string length(const string &self)  {
	if (isString(self))
		return setString(toString((long)(self.length()-2)));
	return "nil";
}

// * Substring extraction
const string subString(const string &self, const string &params) {
	/*
	POR HACER, HAY QUE COGER LOS DOS PARMETROS A PARTIR DEL
	ACCESO COM DE LA MQUINA ABSTRACTA
	*/
	return "nil";
}

