#include "lex.h"
#include <fstream>
#include <sstream>
#include <string>
#include <iostream>

using namespace std;

unsigned yylineno=1;

static int siguienteCaracter(istream *in) {
  char c;
  in->get(c);
  if (c=='\n') yylineno++;
  return c;
  }

static void devuelveCaracter(istream *in,char c) {
  if (c=='\n') yylineno--;
  in->putback(c);
  }

static void limpiarEntrada(istream *in) {
  // * Lee todos los caracteres basura hasta que encuentra uno vlido
  // * Tambin elimina los comentarios
  char c;
  do {
    c=siguienteCaracter(in);
    }
  while ( (c==' '||c=='\t'||c=='\n')&&!in->eof() );
  // * Devolvemos el token NO basura
  devuelveCaracter(in,c);
  }

string yylex(istream *in) {
  limpiarEntrada(in);
  string lexema;
  // * El siguiente caracter NO es basura
  char c=siguienteCaracter(in);
  if ( (c>='a'&&c<='z') || (c>='A'&&c<='Z') ) {
    lexema=c;
    char otroChar=siguienteCaracter(in);
    while ( (otroChar>='0'&&otroChar<='9')||
            (otroChar>='a'&&otroChar<='z')||
            (otroChar>='A'&&otroChar<='Z') ) {
      lexema+=otroChar;
      otroChar=siguienteCaracter(in);
      }
    devuelveCaracter(in,otroChar);
    return lexema;
    }
  if (c=='<') {
    // * Cadena
    int ambito=1;
    lexema=c;
    do {
      c=siguienteCaracter(in);
      lexema+=c;
      if (c=='<') { 
		char otro=siguienteCaracter(in);
		if (otro!='-') ambito++;
		devuelveCaracter(in,otro);
		}
      if (c=='>') ambito--;
    }
    while (ambito && !in->eof());
    return lexema;
    }
  cerr<<"Token desconocido.\n";
  return "";
  }


